<?php
// Version: 1.1; MessageIndex

function template_main()
{
	global $context, $settings, $options, $scripturl, $modSettings, $txt;

	echo '
                        <a name="top"></a>';

	echo theme_linktree();

	if (isset($context['boards']) && (!empty($options['show_children']) || $context['start'] == 0))
	{
		echo '
		<dl class="boards_desc">
			<dt>
				<span>', $txt['parent_boards'], '</span>
			</dt>
				
				<dd class="msgicon_desc">', $txt['padexx_access'] ,'</dd>
				
				<dd class="msgbody_desc">&nbsp;</dd>
				
				<dd class="lpost_desc">', $txt['padexx_lpost'] ,'</dd>
				
				<dd class="bstats_desc">', $txt['padexx_bstats'] ,'</dd>
			</dl>';
			
			echo'
			<dl class="boards">';

		foreach ($context['boards'] as $board)
		{
				echo '
				<dt', $board['new'] ? ' class="new"' : '', '', $board['children_new'] ? ' class="new"' : '', '><a href="', $board['href'], '" id="b', $board['id'], '">', $board['name'], '</a>';

				// Show the "Child Boards: ". (there's a link_children but we're going to bold the new ones...)
				if (!empty($board['children']))
				{
					// Sort the links into an array with new boards bold so it can be imploded.
					$children = array();
					/* Each child in each board's children has:
							id, name, description, new (is it new?), topics (#), posts (#), href, link, and last_post. */
					foreach ($board['children'] as $child)
					{
							$child['link'] = '<a href="' . $child['href'] . '" title="' . ($child['new'] ? $txt[333] : $txt[334]) . ' (' . $txt[330] . ': ' . $child['topics'] . ', ' . $txt[21] . ': ' . $child['posts'] . ')">' . $child['name'] . '</a>';
							$children[] = $child['new'] ? '' . $child['link'] . '' : $child['link'];
					}

					echo '<p class="chboards">[<strong>', $txt['parent_boards'], '</strong>: ', implode(' | ', $children), ']</p>';
				}
                                
                                echo '</dt>
                                <dd class="msgicon"><a href="', $scripturl, '?action=unread;board=', $board['id'], '.0">';

                                // If the board is new, show a strong indicator.
				if ($board['new'])
					echo '<img src="', $settings['images_url'], '/on.gif" alt="', $txt[333], '" title="', $txt[333], '" />';
				// This board doesn't have new posts, but its children do.
				elseif ($board['children_new'])
					echo '<img src="', $settings['images_url'], '/on.gif" alt="', $txt[333], '" title="', $txt[333], '" />';
				// No new posts at all! The agony!!
				else
					echo '<img src="', $settings['images_url'], '/off.gif" alt="', $txt[334], '" title="', $txt[334], '" />';

                                echo '</a></dd>
				<dd class="msgbody">', $board['description'], '&nbsp;';

				// Show the "Moderators: ". Each has name, href, link, and id. (but we're gonna use link_moderators.)
				if (!empty($board['moderators']))
					echo '<br /><span class="mods"><em>', count($board['moderators']) == 1 ? $txt[298] : $txt[299], ':</em> ', implode(', ', $board['link_moderators']), '<br /><br /></span>';

				echo '</dd>';

				// Show some basic information about the number of posts, etc.
					echo '<dd class="bstats">', $board['posts'] ,' &frasl; ', $board['topics'] ,'</dd>';

				/* The board's and children's 'last_post's have:
				time, timestamp (a number that represents the time.), id (of the post), topic (topic id.),
				link, href, subject, start (where they should go for the first unread post.),
				and member. (which has id, name, link, href, username in it.) */
				echo '<dd class="lpost"><strong>', $txt[22], '</strong>  ', $txt[525], ' ', $board['last_post']['member']['link'] , '<br />', $txt['smf88'], ' ', $board['last_post']['link'], '<br />', $txt[30], ' ', $board['last_post']['time'], '</dd>';

			}
			echo '
			</dl>';
	}

	if (!$context['no_topic_listing'])
	{
		echo '
			<ul class="msgmenu">
				', theme_show_buttons(), '
			</ul>
			<span class="pages2">
				', $txt[139], ': ', $context['page_index'], !empty($modSettings['topbottomEnable']) ? $context['menu_separator'] . '&nbsp;&nbsp;<a href="#tot"><strong>' . $txt['topbottom4'] . '</strong></a>' : '', '
			</span>
                        <div class="clr"></div>';

		// If Quick Moderation is enabled start the form.
		if (!empty($options['display_quick_mod']) && !empty($context['topics']))
			echo '
      	                <form action="', $scripturl, '?action=quickmod;board=', $context['current_board'], '.', $context['start'], '" method="post" name="quickModForm" id="quickModForm" style="margin: 0;">';

      		echo '
      			<table id="messagetable" border="0" cellspacing="1" cellpadding="4">
      				<tr>';

      		// Are there actually any topics to show?
      		if (!empty($context['topics']))
      		{
      			echo '
      					<td class="catbg3 cella1" colspan="2"></td>
      					<td class="catbg3"><a href="', $scripturl, '?board=', $context['current_board'], '.', $context['start'], ';sort=subject', $context['sort_by'] == 'subject' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[70], $context['sort_by'] == 'subject' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>
      					<td class="catbg3 cella2"><a href="', $scripturl, '?board=', $context['current_board'], '.', $context['start'], ';sort=starter', $context['sort_by'] == 'starter' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[109], $context['sort_by'] == 'starter' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>
      					<td class="catbg3 cella3"><a href="', $scripturl, '?board=', $context['current_board'], '.', $context['start'], ';sort=replies', $context['sort_by'] == 'replies' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[110], $context['sort_by'] == 'replies' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>
      					<td class="catbg3 cella3"><a href="', $scripturl, '?board=', $context['current_board'], '.', $context['start'], ';sort=views', $context['sort_by'] == 'views' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[301], $context['sort_by'] == 'views' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>
      					<td class="catbg3 cella4"><a href="', $scripturl, '?board=', $context['current_board'], '.', $context['start'], ';sort=last_post', $context['sort_by'] == 'last_post' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[111], $context['sort_by'] == 'last_post' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>';

      			// Show a "select all" box for quick moderation?
      			if (!empty($options['display_quick_mod']) && $options['display_quick_mod'] == 1)
      				echo '
      					<td class="catbg3 cella5">
      						<input type="checkbox" onclick="invertAll(this, this.form, \'topics[]\');" class="check" />
      					</td>';
      			// If it's on in "image" mode, don't show anything but the column.
      			elseif (!empty($options['display_quick_mod']))
      				echo '
      					<td class="catbg3 cella6"></td>';
      		}
      		// No topics.... just say, "sorry bub".
      		else
      			echo '
      					<td class="catbg3 twidth" colspan="7"><strong>', $txt[151], '</strong></td>';

      		echo '
      				</tr>';

      		if (!empty($settings['display_who_viewing']))
      		{
      			echo '
      				<tr>
      					<td id="whviewingms" colspan="' , !empty($options['display_quick_mod']) ? '8' : '7' , '">';
      			if ($settings['display_who_viewing'] == 1)
      				echo count($context['view_members']), ' ', count($context['view_members']) == 1 ? $txt['who_member'] : $txt[19];
      			else
      				echo empty($context['view_members_list']) ? '0 ' . $txt[19] : implode(', ', $context['view_members_list']) . ((empty($context['view_num_hidden']) or $context['can_moderate_forum']) ? '' : ' (+ ' . $context['view_num_hidden'] . ' ' . $txt['hidden'] . ')');
      			echo $txt['who_and'], $context['view_num_guests'], ' ', $context['view_num_guests'] == 1 ? $txt['guest'] : $txt['guests'], $txt['who_viewing_board'], '
      					</td>
      				</tr>';
      		}

      		foreach ($context['topics'] as $topic)
      		{
      			// Do we want to seperate the sticky and lock status out?
      			if (!empty($settings['seperate_sticky_lock']) && strpos($topic['class'], 'sticky') !== false)
      				$topic['class'] = substr($topic['class'], 0, strrpos($topic['class'], '_sticky'));
      			if (!empty($settings['seperate_sticky_lock']) && strpos($topic['class'], 'locked') !== false)
      				$topic['class'] = substr($topic['class'], 0, strrpos($topic['class'], '_locked'));

      			echo '
      				<tr>
      					<td class="windowbg2', $context['browser']['is_ie'] ? ' cellb5' : ' cellb1', '">
      						<img src="', $settings['images_url'], '/topic/', $topic['class'], '.gif" alt="" />
      					</td>
      					<td class="windowbg2', $context['browser']['is_ie'] ? ' cellb5' : ' cellb1', '">
      						<img src="', $topic['first_post']['icon_url'], '" alt="" />
      					</td>
      					<td class="windowbg' , $topic['is_sticky'] ? '3' : '' , ' cellb2" ', (!empty($topic['quick_mod']['remove']) ? 'id="topic_' . $topic['first_post']['id'] . '" onmouseout="mouse_on_div = 0;" onmouseover="mouse_on_div = 1;" ondblclick="modify_topic(\'' . $topic['id'] . '\', \'' . $topic['first_post']['id'] . '\', \'' . $context['session_id'] . '\');"' : ''), '>';

      			if (!empty($settings['seperate_sticky_lock']))
      				echo $topic['is_locked'] ? '<img src="' . $settings['images_url'] . '/icons/quick_lock.gif" align="right" alt="" id="lockicon' . $topic['first_post']['id'] . '"  />' : '' , '
      						' , $topic['is_sticky'] ? '<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" align="right" alt="" id="stickyicon' . $topic['first_post']['id'] . '" />' : '';

      			echo $topic['is_sticky'] ? '<b>' : '' , '<span id="msg_' . $topic['first_post']['id'] . '">', $topic['first_post']['link'], '</span>', $topic['is_sticky'] ? '</b>' : '';

      			// Is this topic new? (assuming they are logged in!)
      			if ($topic['new'] && $context['user']['is_logged'])
      					echo '
      						<a href="', $topic['new_href'], '" id="newicon' . $topic['first_post']['id'] . '"><img src="', $settings['images_url'], '/', $context['user']['language'], '/new.gif" alt="', $txt[302], '" /></a>';

      			echo '
      						<small id="pages' . $topic['first_post']['id'] . '">', $topic['pages'], '</small>
      					</td>
      					<td class="windowbg2 cellb3">
      						', $topic['first_post']['member']['link'], '
      					</td>
      					<td class="windowbg' , $topic['is_sticky'] ? '3' : '' , ' cella6">
      						', $topic['replies'], '
      					</td>
      					<td class="windowbg' , $topic['is_sticky'] ? '3' : '' , ' cella6">
      						', $topic['views'], '
      					</td>
      					<td class="windowbg2 cellb4">
      						<a href="', $topic['last_post']['href'], '"><img src="', $settings['images_url'], '/icons/last_post.gif" alt="', $txt[111], '" title="', $txt[111], '" class="msglpost" /></a>
      						<span class="smalltext">
      							', $topic['last_post']['time'], '<br />
      							', $txt[525], ' ', $topic['last_post']['member']['link'], '
      						</span>
      					</td>';

      			// Show the quick moderation options?
      			if (!empty($options['display_quick_mod']))
      			{
      				echo '
      					<td class="windowbg' , $topic['is_sticky'] ? '3' : '' , ' cella6">';
      				if ($options['display_quick_mod'] == 1)
      					echo '
      						<input type="checkbox" name="topics[]" value="', $topic['id'], '" class="check" />';
      				else
      				{
      					// Check permissions on each and show only the ones they are allowed to use.
      					if ($topic['quick_mod']['remove'])
      						echo '<a href="', $scripturl, '?action=quickmod;board=', $context['current_board'], '.', $context['start'], ';actions[', $topic['id'], ']=remove;sesc=', $context['session_id'], '" onclick="return confirm(\'', $txt['quickmod_confirm'], '\');"><img src="', $settings['images_url'], '/icons/quick_remove.gif" width="16" alt="', $txt[63], '" title="', $txt[63], '" /></a>';

      					if ($topic['quick_mod']['lock'])
      						echo '<a href="', $scripturl, '?action=quickmod;board=', $context['current_board'], '.', $context['start'], ';actions[', $topic['id'], ']=lock;sesc=', $context['session_id'], '" onclick="return confirm(\'', $txt['quickmod_confirm'], '\');"><img src="', $settings['images_url'], '/icons/quick_lock.gif" width="16" alt="', $txt['smf279'], '" title="', $txt['smf279'], '" /></a>';

      					if ($topic['quick_mod']['lock'] || $topic['quick_mod']['remove'])
      						echo '<br />';

      					if ($topic['quick_mod']['sticky'])
      						echo '<a href="', $scripturl, '?action=quickmod;board=', $context['current_board'], '.', $context['start'], ';actions[', $topic['id'], ']=sticky;sesc=', $context['session_id'], '" onclick="return confirm(\'', $txt['quickmod_confirm'], '\');"><img src="', $settings['images_url'], '/icons/quick_sticky.gif" width="16" alt="', $txt['smf277'], '" title="', $txt['smf277'], '" /></a>';

      					if ($topic['quick_mod']['move'])
      						echo '<a href="', $scripturl, '?action=movetopic;board=', $context['current_board'], '.', $context['start'], ';topic=', $topic['id'], '.0"><img src="', $settings['images_url'], '/icons/quick_move.gif" width="16" alt="', $txt[132], '" title="', $txt[132], '" /></a>';
      				}
      				echo '</td>';
      			}
      			echo '
      				</tr>';
      		}

      		if (!empty($options['display_quick_mod']) && $options['display_quick_mod'] == 1 && !empty($context['topics']))
      		{
      			echo '
      				<tr>
      					<td colspan="8" align="right">
      						<select name="qaction"', $context['can_move'] ? ' onchange="this.form.moveItTo.disabled = (this.options[this.selectedIndex].value != \'move\');"' : '', '>
      							<option value="">--------</option>
      							', $context['can_remove'] ? '<option value="remove">' . $txt['quick_mod_remove'] . '</option>' : '', '
      							', $context['can_lock'] ? '<option value="lock">' . $txt['quick_mod_lock'] . '</option>' : '', '
      							', $context['can_sticky'] ? '<option value="sticky">' . $txt['quick_mod_sticky'] . '</option>' : '', '
      							', $context['can_move'] ? '<option value="move">' . $txt['quick_mod_move'] . ': </option>' : '', '
      							', $context['can_merge'] ? '<option value="merge">' . $txt['quick_mod_merge'] . '</option>' : '', '
      							<option value="markread">', $txt['quick_mod_markread'], '</option>
      						</select>';

      			if ($context['can_move'])
      			{
      					echo '
      						<select class="moveItTo" name="move_to" disabled="disabled">';

      					foreach ($context['jump_to'] as $category)
      							foreach ($category['boards'] as $board)
      							{
      								if (!$board['is_current'])
      									echo '
      							<option value="', $board['id'], '"', !empty($board['selected']) ? ' selected="selected"' : '', '>', str_repeat('-', $board['child_level'] + 1), ' ', $board['name'], '</option>';
      							}
      					echo '
      						</select>';
      			}
      			echo '
      						<input class="moveItTo" type="submit" value="', $txt['quick_mod_go'], '" onclick="return document.topicForm.qaction.value != \'\' &amp;&amp; confirm(\'', $txt['quickmod_confirm'], '\');" />
      					</td>
      				</tr>';
      		}

      		echo '
      			</table>
      			<a name="bot"></a>';

      		// Finish off the form - again.
      		if (!empty($options['display_quick_mod']) && !empty($context['topics']))
      				echo '
      			<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
      			</form>';
		echo '
			<ul class="msgmenu">
				', theme_show_buttons(), '
			</ul>
			<div class="pages2">
				', $txt[139], ': ', $context['page_index'], !empty($modSettings['topbottomEnable']) ? $context['menu_separator'] . '&nbsp;&nbsp;<a href="#bot"><strong>' . $txt['topbottom5'] . '</strong></a>' : '', '
			</div>
                        <div class="alt"></div>';
	}


	// Show breadcrumbs at the bottom too?
	echo theme_linktree();

	if (!$context['no_topic_listing'])
			echo '
                        <div id="msgicons1">
                		', !empty($modSettings['enableParticipation']) ? '
                		<img src="' . $settings['images_url'] . '/topic/my_normal_post.gif" alt="" align="middle" /> ' . $txt['participation_caption'] . '<br />' : '', '
                		<img src="' . $settings['images_url'] . '/topic/normal_post.gif" alt="" align="middle" /> ' . $txt[457] . '<br />
                		<img src="' . $settings['images_url'] . '/topic/hot_post.gif" alt="" align="middle" /> ' . $txt[454] . '<br />
                		<img src="' . $settings['images_url'] . '/topic/veryhot_post.gif" alt="" align="middle" /> ' . $txt[455] . '
                        </div>
                        <div id="msgicons2">
                		<img src="' . $settings['images_url'] . '/icons/quick_lock.gif" alt="" align="middle" /> ' . $txt[456] . '<br />' . ($modSettings['enableStickyTopics'] == '1' ? '
                		<img src="' . $settings['images_url'] . '/icons/quick_sticky.gif" alt="" align="middle" /> ' . $txt['smf96'] . '<br />' : '') . ($modSettings['pollMode'] == '1' ? '
                		<img src="' . $settings['images_url'] . '/topic/normal_poll.gif" alt="" align="middle" /> ' . $txt['smf43'] : '') . '
                        </div>';

	echo '
                        <form action="', $scripturl, '" method="get" name="jumptoForm" id="msgjmp">
				<span class="smalltext"><label for="jumpto">' . $txt[160] . '</label>:</span>
				<select name="jumpto" id="jumpto" onchange="if (this.selectedIndex > 0 &amp;&amp; this.options[this.selectedIndex].value) window.location.href = smf_scripturl + this.options[this.selectedIndex].value.substr(smf_scripturl.indexOf(\'?\') == -1 || this.options[this.selectedIndex].value.substr(0, 1) != \'?\' ? 0 : 1);">
					<option value="">' . $txt[251] . ':</option>';

	// Show each category - they all have an id, name, and the boards in them.
	foreach ($context['jump_to'] as $category)
	{
		// Show the category name with a link to the category. (index.php#id)
		echo '
					<option value="" disabled="disabled">-----------------------------</option>
					<option value="#', $category['id'], '">', $category['name'], '</option>
					<option value="" disabled="disabled">-----------------------------</option>';

		/* Now go through each board - they all have:
				id, name, child_level (how many parents they have, basically...), and is_current. (is this the current board?) */
		foreach ($category['boards'] as $board)
		{
			// Show some more =='s if this is a child, so as to make it look nice.
			echo '
					<option value="?board=', $board['id'], '.0"', $board['is_current'] ? ' selected="selected"' : '', '> ', str_repeat('==', $board['child_level']), '=> ', $board['name'], '</option>';
		}
	}

	echo '
				</select>
				<input type="button" value="', $txt[161], '" onclick="if (this.form.jumpto.options[this.form.jumpto.selectedIndex].value) window.location.href = \'', $scripturl, '\' + this.form.jumpto.options[this.form.jumpto.selectedIndex].value;" />
			</form>
        		<div style="clear: both;"></div>';

        	// Javascript for inline editing.
        	echo '
        		<script language="JavaScript" type="text/javascript" src="' . $settings['default_theme_url'] . '/xml_board.js"></script>
        		<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
                        	// Hide certain bits during topic edit.
                        	hide_prefixes.push("lockicon", "stickyicon", "pages", "newicon");
                        
                        	// Use it to detect when we\'ve stopped editing.
                        	document.onmousedown = mouse_down;
                        
                        	var mouse_on_div;
                        	function mouse_down(e)
                        	{
                        		if (in_edit_mode == 1 && mouse_on_div == 0)
                        			modify_topic_save("', $context['session_id'], '");
                        	}
                        
                        	// For templating, shown when an inline edit is made.
                        	function modify_topic_show_edit(subject)
                        	{
                        		// Just template the subject.
                        		setInnerHTML(cur_subject_div, \'<input type="text" name="subject" value="\' + subject + \'" size="60" style="width: 99%;"  maxlength="80" /><input type="hidden" name="topic" value="\' + cur_topic_id + \'" /><input type="hidden" name="msg" value="\' + cur_msg_id.substr(4) + \'" />\');
                        	}
                        
                        	// And the reverse for hiding it.
                        	function modify_topic_hide_edit(subject)
                        	{
                        		// Re-template the subject!
                        		setInnerHTML(cur_subject_div, \'<a href="', $scripturl, '?topic=\' + cur_topic_id + \'.0">\' + subject + \'</a>\');
                        	}
        		// ]]></script>';
}

function theme_show_buttons()
{
	global $context, $settings, $options, $txt, $scripturl;

	$buttonArray = array();

	// If they are logged in, and the mark read buttons are enabled..
	if ($context['user']['is_logged'] && $settings['show_mark_read'])
		$buttonArray[] = '<li class="markread"><a href="' . $scripturl . '?action=markasread;sa=board;board=' . $context['current_board'] . '.0;sesc=' . $context['session_id'] . '">' . $txt['mark_read_short'] . '</a></li>';

	// If the user has permission to show the notification button... ask them if they're sure, though.
	if ($context['can_mark_notify'])
		$buttonArray[] = '<li class="notify"><a href="' . $scripturl . '?action=notifyboard;sa=' . ($context['is_marked_notify'] ? 'off' : 'on') . ';board=' . $context['current_board'] . '.' . $context['start'] . ';sesc=' . $context['session_id'] . '" onclick="return confirm(\'' . ($context['is_marked_notify'] ? $txt['notification_disable_board'] : $txt['notification_enable_board']) . '\');">' . $txt[125] . '</a></li>';

	// How about new polls, can the user post those?
	if ($context['can_post_poll'])
		$buttonArray[] = '<li class="newpoll"><a href="' . $scripturl . '?action=post;board=' . $context['current_board'] . '.0;poll">' . $txt['smf20'] . '</a></li>';

	// Are they allowed to post new topics?
	if ($context['can_post_new'])
		$buttonArray[] = '<li class="newtopic"><a href="' . $scripturl . '?action=post;board=' . $context['current_board'] . '.0">' . $txt['smf258'] . '</a></li>';

	return implode($buttonArray);
}
?>